/*
 * ARJ.H
 *
 *  This file is part of DOSZIP
 *  Copyright (c) 1996 Hjort Nidudsson.
 *
 * .ARJ file format
 */
#ifndef __INC_ARJ
#define __INC_ARJ
#if !defined(__INC_DEFS)
 #include <defs.h>
#endif

#define ARJVERSION     	3
#define ARJMVERSION    	6
#define ARJXVERSION    	3
#define ARJX1VERSION   	1

#define ARJHEADERID     0xEA60
#define ARJHEADERIDHI   0xEA
#define ARJHEADERIDLO   0x60

#define ARJHEADERSIZE	30
#define ARJHEADERVSIZE	34

#define ARJMAXFNAME	512
#define ARJMAXCOMMENT	2048
#define ARJMAXHEADER	(ARJMAXFNAME + ARJMAXCOMMENT + ARJMAXHEADER + 10)

#define ARJDEFAULTMET  	1
#define ARJDEFAULTYPE	0

#define ARJBINARY   	0
#define ARJTEXT		1
#define ARJCOMMENT	2
#define ARJSUBDIR	3
#define ARJLABEL	4

#define ARJGARBLED	0x01
#define ARJVOLUME	0x04
#define ARJEXTFILE	0x08
#define ARJPATHSYM	0x10
#define ARJBACKUP	0x20

#define ARJEROK        	0
#define ARJERWARN      	1
#define ARJERFAIL	2
#define ARJERCRC       	3
#define ARJERSECURE    	4
#define ARJERWRITE     	5
#define ARJERREAD     	6
#define ARJEROPEN      	7

#ifdef __cplusplus
 extern "C" {
#endif

typedef struct {
	WORD	id;
	WORD	size_head;
	BYTE	size_filehead;
	BYTE	version;
	BYTE	min_version;
	BYTE	os;
	BYTE	flag;
	BYTE	method;
	BYTE	type;
	BYTE	password;
	WORD	time;
	WORD	date;
	DWORD	compressed_size;
	DWORD	original_size;
	DWORD	crc;
	WORD 	name_pos;
	WORD	file_access_mode;
	WORD	host_data;
      } ARJ;

#ifdef __cplusplus
 }
#endif
#endif /* __INC_ARJ */